// mlsstr.h            see license.txt for copyright and terms of use
// handles lexically embedded ML
// based on ccsstr.h

#ifndef MLSSTR_H
#define MLSSTR_H

#include "embedded.h"      // EmbeddedLang

class MLSubstrateTest;

class MLSubstrate : public EmbeddedLang {
private:
  enum State {
    ST_NORMAL,       // normal text
    ST_STRING,       // inside a string literal
    ST_CHAR,         // inside a char literal
    ST_COMMENT,      // inside a comment
    ST_APOSTROPHE1,  // last char was an apostrophe
    ST_APOSTROPHE2,  // char before last was an apostrophe
    NUM_STATES
  } state;
  int nesting;       // depth of paren/bracket/brace nesting
  int comNesting;    // depth of comment nesting (in ST_COMMENT)
  char prev;         // previous character

  // so test code can interrogate internal state
  friend class MLSubstrateTest;

public:
  MLSubstrate(ReportError *err = NULL);
  virtual ~MLSubstrate();

  // EmbeddedLang entry points (see gramlex.h for description
  // of each function)
  virtual void reset(int initNest = 0);
  virtual void handle(char const *str, int len, char finalDelim);
  virtual bool zeroNesting() const;
  virtual string getFuncBody() const;
  virtual string getDeclName() const;
};

#endif // MLSSTR_H
